
slowdown:	;this exists for systems that run too fast
	rts

		
newline:
	lda #0		;new line
	sta z_d

	inc z_e

	lda z_e
	cmp #23			;at bottom of screen
	bcs lbl52779		;no? return, else cls!
	rts
lbl52779

cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #$20
		sta z_h

		lda #40		;width,height
		sta z_b
		lda #$19
		sta z_c

		jsr fillarea
	pla
	sta	z_c
	pla
	sta z_b
	
	pla
	sta	z_l
	pla
	sta z_h
	rts


printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0

printchar:			;print char a with sprite routine
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	tax
	pha
	;pushpair z_bc
	lda z_d
	pha
	lda z_e
	pha
	
	lda z_h
	pha
	lda z_l
	pha
		lda #0			;Zero High byte (Use A as Low)
		sta z_H
		
		lda z_E
		;Y* 40 = 		%00101000	(Y*8 + Y*32)
		asl				;00000001
		rol z_H			;00000010	*2
		asl
		rol z_H			;00000100	*4
		asl
		rol z_H			;00001000	*8
		sta z_L
		
		lda z_H			;Back up Y*8 for later
		pha
			lda z_L			;00001000
			asl
			rol z_H			;00010000	*16
			asl
			rol z_H			;00100000	*32
			
			clc
			adc z_D	;Add Xpos
			adc z_L
			sta z_L
		pla	
		adc z_H			;Get Y*32
		ora #$18		;Screen Base at $1800
		sta z_H

		txa
		cmp #96			;Check if character >96
		bcs	PrintCharOK
		sec
		sbc #$20		;Fix Uppercase
PrintCharOK:	
		ldx #0
		sta (z_HL,x) 	;Store in video memory
	pla
	sta	z_l
	pla
	sta z_h
	pla
	sta	z_e
	pla
	sta z_d
	;pullpairsafe z_bc
	pla
	inc z_d
	rts

	
	
			
;
	;We Return ---FRLDU in z_h for Player 0, and z_L for Player 1
	ifdef BuildA80	
ReadJoystick:
		lda PIA+$0	;22221111 - RLDU in player controls
		and #%00001111	;Bottom Nibble is Player 1 Joystick
		ora #%11100000
		sta z_h

		lda GTIA+$10	;$D010 - TRIG0 - joystick trigger 0
		clc
		rol
		rol
		rol
		rol
		ora z_h			;Joystick 1 Done
		sta z_h			
		
	rts
	endif
	
	
	ifdef BuildA52		;Atari 5200 doesn't have PIA 
ReadJoystick:
	lda GTIA+$10		;$C010 - TRIG0 - joystick trigger 0
	sta z_as
	
	lda pokey+0			;$E800 - POT0 - game paddle 0
	jsr Player_ReadControlsProcessAnalog
	
	lda pokey+1			;$E801 - POT1 - game paddle 1
	jsr Player_ReadControlsProcessAnalog
	
	lda #%11100000
	ora z_as
	sta z_h
	rts
	
	;Convert Analog to Digital
Player_ReadControlsProcessAnalog:
	cmp #255-64
	bcs Player_ReadControlsProcessHigh
	cmp #64
	bcc Player_ReadControlsProcessLow
	sec
	bcs Player_ReadControlsProcessB
;		rol z_h
;		sec
;		rol z_h
;		rts
Player_ReadControlsProcessHigh:		;B/R
	clc
Player_ReadControlsProcessB:
	rol z_as
	sec
	rol z_as
	rts
Player_ReadControlsProcessLow:		;T/L
	sec
	rol z_as
	clc
	rol z_as
	rts
	endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Display List
  
    org $b000
	
Smode equ 2
DisplayList:				;Display list data
	db $70,$70,$70;$70 7= 8 blank lines 0= blank lines
	db $40+2				;$40+2
	
	dw $1800				;Screen starts at &1800
		
	db $02,$02,$02,$02,$02,$02 ;Screen mode (2) lines
	db $02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
		
	db $41					;Loop
	dw DisplayList
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Rom Header
        org $bffd
        db $FF         ;Disable Atari Logo
        dw ProgramStart;program Start
		
		
		