
slowdown:	;this exists for systems that run too fast
	rts


newline:
	lda #0		;new line
	sta z_d

	inc z_e

	lda z_e
	cmp #23			;at bottom of screen
	bcs lbl52779		;no? return, else cls!
	rts
lbl52779

cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #$20
		sta z_h

		lda #$28		;width,height
		sta z_b
		lda #$19
		sta z_c

		jsr fillarea
	pla
	sta	z_c
	pla
	sta z_b
	
	pla
	sta	z_l
	pla
	sta z_h
	rts


printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0

printchar:			;print char a with sprite routine	
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	
	tax
	pha
	;pushpair z_bc
	lda z_d
	pha
	lda z_e
	pha
	
	lda z_h
	pha
	lda z_l
	pha
		txa
		sec
		sbc #32					;no char below 32
		cmp #64
		bcc notlowercase
			sec
			sbc #32		;we don't define lowercase, convert to upper!
notlowercase:
			sta z_h
			lda #0
			lsr z_h
			ror
			lsr z_h
			ror
			lsr z_h
			ror
			lsr z_h
			ror			;font * 16
			adc #<fontdata
			sta z_l
			lda z_h
			adc #>fontdata
			sta z_h
	

	
			lda z_e				;Ypos *$200
			asl 
			sta z_as
			
			lda #0
			sta z_e
			
			lda z_d
			lsr 
			ror z_e
			lsr 
			ror z_e
			lsr 
			ror z_e
			lsr 
			ror z_e				;Xpos * 16 
			
			clc
			adc z_as
			adc #$50		;Vram at $5000
			sta z_d
			
			ldy #16-1
PrintCharByte:			
			lda (z_hl),y
			sta (z_de),y
			dey 
			bpl PrintCharByte
	pla
	sta	z_l
	pla
	sta z_h
	pla
	sta	z_e
	pla
	sta z_d
	;pullpairsafe z_bc
	pla
	inc z_d
	rts

	

readjoystick:
	lda #$F0				;Set port to read (For fire button)
	STA $FE43				;SN76489 - Data Direction
	sta z_as
	
	;lda #%00000000			;Get Channel 0 - Joy 1 LR
	jsr Player_ReadControlsGetData
	lda #%00000001			;Get Channel 1 - Joy 1 UD
	jsr Player_ReadControlsGetData
		
	lda $FE40
	and #%00010000			;Get the fire button 1 (PB4 / PB5)
	ora z_as
	eor #%11101111
	;sta z_h
	rts
	
	;See page 429 of the 'BBC Microcomputer Advanced user Guide' 
	
Player_ReadControlsGetData:	;We need to convert analog to digital
	sta $FEC0						;Select channel
Player_ReadControlsDualWait:
	lda $FEC0						;Get Data
	and #%10000000
	bne Player_ReadControlsDualWait	;0= data ready
	
	lda $FEC1						;8 bit analog data
	cmp #255-32
	bcs Player_ReadControlsDualHigh
	cmp #32				
	bcc Player_ReadControlsDualLow 	;Centered
	clc
	bcc Player_ReadControlsDualB	;efective branch always
;	rol z_as
;	clc
;	rol z_as
;	rts
	
Player_ReadControlsDualLow:		;R/D
	sec
Player_ReadControlsDualB:
	rol z_as
	clc
	rol z_as
	rts
Player_ReadControlsDualHigh:	;U/L
	clc
	rol z_as
	sec
	rol z_as
	rts
	
		

fontdata:
		DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 
        DB $11,$10,$10,$10,$10,$00,$01,$00     ;  0
        DB $00,$88,$80,$80,$80,$00,$80,$00     ;  1
        DB $22,$62,$20,$00,$00,$00,$00,$00     ;  2
        DB $88,$C8,$80,$00,$00,$00,$00,$00     ;  3
        DB $00,$22,$70,$20,$25,$02,$00,$00     ;  4
        DB $00,$88,$C0,$80,$84,$08,$00,$00     ;  5
        DB $11,$32,$40,$30,$10,$25,$01,$00     ;  6
        DB $88,$EA,$80,$C0,$20,$84,$08,$00     ;  7
        DB $00,$C8,$C0,$10,$20,$04,$08,$00     ;  8
        DB $22,$40,$80,$00,$00,$24,$06,$00     ;  9
        DB $11,$22,$20,$70,$90,$80,$07,$00     ; 10
        DB $00,$88,$80,$20,$40,$84,$02,$00     ; 11
        DB $00,$10,$30,$00,$00,$00,$00,$00     ; 12
        DB $CC,$C8,$00,$00,$00,$00,$00,$00     ; 13
        DB $11,$10,$30,$30,$30,$01,$01,$00     ; 14
        DB $88,$88,$00,$00,$00,$80,$08,$00     ; 15
        DB $11,$10,$00,$00,$00,$01,$01,$00     ; 16
        DB $88,$88,$C0,$C0,$C0,$80,$08,$00     ; 17
        DB $00,$44,$20,$10,$10,$20,$04,$00     ; 18
        DB $88,$91,$A0,$C0,$40,$20,$01,$00     ; 19
        DB $00,$10,$10,$70,$10,$01,$00,$00     ; 20
        DB $00,$88,$80,$E0,$80,$80,$00,$00     ; 21
        DB $00,$00,$00,$00,$00,$01,$01,$03     ; 22
        DB $00,$00,$00,$00,$00,$80,$08,$00     ; 23
        DB $00,$00,$00,$70,$07,$00,$00,$00     ; 24
        DB $00,$00,$00,$E0,$0E,$00,$00,$00     ; 25
        DB $00,$00,$00,$00,$00,$01,$01,$00     ; 26
        DB $00,$00,$00,$00,$00,$80,$08,$00     ; 27
        DB $00,$00,$00,$10,$20,$04,$08,$00     ; 28
        DB $22,$40,$80,$00,$00,$00,$00,$00     ; 29
        DB $77,$C8,$D0,$D0,$49,$0C,$07,$00     ; 30
        DB $CC,$62,$60,$60,$42,$06,$0C,$00     ; 31
        DB $11,$10,$10,$10,$10,$01,$00,$00     ; 32
        DB $00,$88,$80,$80,$80,$80,$08,$00     ; 33
        DB $33,$72,$00,$30,$60,$25,$03,$00     ; 34
        DB $CC,$EA,$60,$C0,$00,$A4,$0C,$00     ; 35
        DB $33,$72,$00,$10,$00,$25,$03,$00     ; 36
        DB $CC,$EA,$60,$C0,$60,$A4,$0C,$00     ; 37
        DB $11,$32,$60,$C0,$70,$00,$00,$00     ; 38
        DB $88,$C8,$40,$C0,$C0,$84,$08,$00     ; 39
        DB $33,$72,$60,$70,$00,$25,$03,$00     ; 40
        DB $CC,$EA,$00,$C0,$60,$A4,$0E,$00     ; 41
        DB $33,$72,$60,$70,$60,$24,$03,$00     ; 42
        DB $CC,$EA,$00,$C0,$60,$24,$0C,$00     ; 43
        DB $33,$72,$00,$00,$10,$01,$01,$00     ; 44
        DB $CC,$EA,$60,$C0,$80,$80,$00,$00     ; 45
        DB $33,$62,$60,$30,$60,$24,$03,$00     ; 46
        DB $CC,$62,$60,$C0,$60,$24,$0C,$00     ; 47
        DB $33,$62,$60,$30,$00,$25,$03,$00     ; 48
        DB $CC,$62,$60,$E0,$60,$A4,$0C,$00     ; 49
        DB $00,$00,$11,$10,$00,$01,$01,$00     ; 50
        DB $00,$00,$88,$80,$00,$80,$08,$00     ; 51
        DB $00,$00,$11,$10,$00,$01,$01,$03     ; 52
        DB $00,$00,$88,$80,$00,$80,$08,$00     ; 53
        DB $00,$10,$30,$60,$30,$01,$00,$00     ; 54
        DB $CC,$C8,$80,$00,$80,$84,$0C,$00     ; 55
        DB $00,$00,$72,$00,$00,$25,$00,$00     ; 56
        DB $00,$00,$EA,$00,$00,$A4,$00,$00     ; 57
        DB $66,$72,$30,$00,$30,$25,$06,$00     ; 58
        DB $00,$00,$80,$C0,$80,$00,$00,$00     ; 59
        DB $33,$72,$00,$10,$00,$10,$01,$00     ; 60
        DB $CC,$62,$60,$C0,$00,$08,$08,$00     ; 61
        DB $77,$C8,$A0,$B0,$C0,$A5,$07,$00     ; 62
        DB $CC,$E2,$60,$60,$42,$00,$0C,$00     ; 63
        DB $11,$32,$60,$60,$70,$24,$02,$00     ; 64
        DB $88,$C8,$60,$60,$E0,$24,$04,$00     ; 65
        DB $33,$62,$60,$70,$60,$24,$03,$00     ; 66
        DB $CC,$62,$60,$C0,$60,$24,$0C,$00     ; 67
        DB $33,$72,$C0,$C0,$C0,$25,$03,$00     ; 68
        DB $88,$C8,$00,$00,$00,$84,$08,$00     ; 69
        DB $33,$62,$60,$60,$60,$24,$03,$00     ; 70
        DB $CC,$40,$60,$60,$60,$04,$08,$00     ; 71
        DB $33,$72,$60,$70,$60,$25,$03,$00     ; 72
        DB $CC,$EA,$00,$80,$00,$A4,$0C,$00     ; 73
        DB $33,$72,$60,$70,$60,$24,$02,$00     ; 74
        DB $88,$C8,$00,$80,$00,$00,$00,$00     ; 75
        DB $33,$62,$C0,$C0,$C0,$24,$03,$00     ; 76
        DB $CC,$62,$00,$00,$C0,$24,$0C,$00     ; 77
        DB $22,$62,$60,$70,$60,$24,$02,$00     ; 78
        DB $44,$62,$60,$E0,$60,$24,$04,$00     ; 79
        DB $11,$10,$10,$10,$10,$01,$00,$00     ; 80
        DB $00,$88,$80,$80,$80,$80,$08,$00     ; 81
        DB $00,$00,$00,$00,$40,$A5,$07,$00     ; 82
        DB $88,$C8,$C0,$C0,$C0,$84,$08,$00     ; 83
        DB $22,$62,$60,$70,$60,$24,$02,$00     ; 84
        DB $44,$62,$C0,$80,$C0,$24,$04,$00     ; 85
        DB $22,$62,$60,$60,$60,$25,$03,$00     ; 86
        DB $00,$00,$00,$00,$00,$A4,$0E,$00     ; 87
        DB $44,$EA,$F0,$D0,$D0,$94,$04,$00     ; 88
        DB $44,$EA,$E0,$60,$60,$24,$04,$00     ; 89
        DB $44,$EA,$F0,$D0,$C0,$84,$04,$00     ; 90
        DB $44,$62,$60,$E0,$E0,$24,$04,$00     ; 91
        DB $33,$62,$C0,$C0,$C0,$24,$03,$00     ; 92
        DB $88,$C8,$60,$60,$60,$84,$08,$00     ; 93
        DB $33,$62,$60,$70,$60,$24,$02,$00     ; 94
        DB $88,$C0,$40,$C0,$00,$00,$00,$00     ; 95
        DB $33,$62,$C0,$C0,$C0,$07,$03,$00     ; 96
        DB $88,$C8,$60,$60,$A0,$04,$0A,$00     ; 97
        DB $33,$62,$60,$70,$60,$24,$02,$00     ; 98
        DB $CC,$62,$60,$C0,$C0,$24,$06,$00     ; 99
        DB $33,$72,$60,$30,$00,$25,$03,$00     ;100
        DB $CC,$E2,$00,$C0,$60,$A4,$0C,$00     ;101
        DB $33,$72,$10,$10,$10,$01,$00,$00     ;102
        DB $CC,$EA,$80,$80,$80,$80,$08,$00     ;103
        DB $22,$62,$60,$60,$60,$24,$03,$00     ;104
        DB $44,$62,$60,$60,$60,$24,$0C,$00     ;105
        DB $22,$62,$60,$60,$60,$21,$01,$00     ;106
        DB $44,$62,$60,$60,$60,$84,$08,$00     ;107
        DB $44,$C8,$D0,$D0,$F0,$4A,$04,$00     ;108
        DB $44,$62,$60,$60,$E0,$4A,$04,$00     ;109
        DB $CC,$62,$30,$30,$60,$84,$04,$00     ;110
        DB $66,$C8,$80,$80,$C0,$24,$04,$00     ;111
        DB $22,$62,$60,$30,$10,$01,$00,$00     ;112
        DB $44,$62,$60,$C0,$80,$80,$08,$00     ;113
        DB $77,$FA,$00,$10,$30,$25,$07,$00     ;114
        DB $CC,$C8,$C0,$80,$00,$A4,$0C,$00     ;115
        DB $11,$32,$30,$30,$30,$21,$01,$00     ;116
        DB $CC,$00,$00,$00,$00,$00,$0C,$00     ;117
        DB $88,$40,$20,$10,$00,$00,$00,$00     ;118
        DB $00,$00,$00,$00,$80,$04,$02,$00     ;119
        DB $33,$00,$00,$00,$00,$00,$03,$00     ;120
        DB $88,$C8,$C0,$C0,$C0,$84,$08,$00     ;121
        DB $11,$32,$70,$10,$10,$01,$01,$00     ;122
        DB $88,$C8,$E0,$80,$80,$80,$08,$00     ;123
        DB $00,$00,$00,$00,$00,$00,$0F,$0F     ;124
        DB $00,$00,$00,$00,$00,$00,$0F,$0F     ;125
        DB $33,$10,$00,$00,$00,$00,$00,$00     ;126
        DB $00,$88,$C0,$00,$00,$00,$00,$00     ;127
        DB $00,$00,$30,$00,$70,$84,$07,$00     ;128
        DB $00,$00,$80,$C0,$C0,$84,$08,$00     ;129
        DB $22,$62,$70,$60,$60,$24,$03,$00     ;130
        DB $00,$00,$CC,$60,$60,$24,$0C,$00     ;131
        DB $00,$00,$33,$64,$60,$24,$03,$00     ;132
        DB $00,$00,$CC,$62,$00,$24,$0C,$00     ;133
        DB $00,$00,$77,$C0,$C0,$84,$07,$00     ;134
        DB $88,$C8,$C0,$C0,$C0,$84,$08,$00     ;135
        DB $00,$00,$33,$64,$70,$24,$03,$00     ;136
        DB $00,$00,$CC,$62,$E0,$00,$0C,$00     ;137
        DB $11,$32,$30,$30,$30,$21,$01,$00     ;138
        DB $CC,$62,$00,$80,$00,$00,$00,$00     ;139
        DB $00,$00,$33,$64,$60,$21,$00,$03     ;140
        DB $00,$00,$CC,$62,$60,$A4,$06,$0C     ;141
        DB $22,$62,$60,$71,$60,$24,$02,$00     ;142
        DB $00,$00,$CC,$62,$60,$24,$04,$00     ;143
        DB $11,$00,$10,$10,$10,$01,$00,$00     ;144
        DB $88,$00,$80,$80,$80,$80,$08,$00     ;145
        DB $00,$00,$00,$00,$00,$20,$06,$03     ;146
        DB $66,$00,$44,$60,$60,$24,$06,$0C     ;147
        DB $22,$66,$60,$60,$70,$24,$02,$00     ;148
        DB $00,$00,$66,$C0,$80,$84,$06,$00     ;149
        DB $11,$10,$10,$10,$10,$01,$00,$00     ;150
        DB $00,$88,$80,$80,$80,$80,$08,$00     ;151
        DB $00,$00,$66,$F9,$D0,$85,$0C,$00     ;152
        DB $00,$00,$CC,$E2,$60,$24,$06,$00     ;153
        DB $00,$00,$33,$64,$60,$24,$02,$00     ;154
        DB $00,$00,$CC,$62,$60,$24,$04,$00     ;155
        DB $00,$00,$33,$64,$60,$24,$03,$00     ;156
        DB $00,$00,$CC,$62,$60,$24,$0C,$00     ;157
        DB $00,$00,$33,$64,$60,$25,$06,$02     ;158
        DB $00,$00,$CC,$62,$60,$84,$00,$00     ;159
        DB $00,$00,$77,$C4,$C0,$25,$00,$00     ;160
        DB $00,$00,$88,$C4,$C0,$84,$0C,$08     ;161
        DB $00,$00,$33,$75,$60,$24,$02,$00     ;162
        DB $00,$00,$88,$C4,$00,$00,$00,$00     ;163
        DB $00,$00,$33,$64,$30,$00,$07,$00     ;164
        DB $00,$00,$CC,$00,$C0,$24,$0C,$00     ;165
        DB $11,$32,$30,$30,$30,$21,$01,$00     ;166
        DB $00,$00,$C0,$00,$00,$A4,$0C,$00     ;167
        DB $00,$00,$22,$60,$60,$24,$03,$00     ;168
        DB $00,$00,$44,$60,$60,$24,$0C,$00     ;169
        DB $00,$00,$22,$60,$60,$21,$01,$00     ;170
        DB $00,$00,$44,$60,$60,$84,$08,$00     ;171
        DB $00,$00,$44,$D9,$D0,$A5,$06,$00     ;172
        DB $00,$00,$44,$62,$60,$A4,$0C,$00     ;173
        DB $00,$00,$CC,$62,$30,$24,$0C,$00     ;174
        DB $00,$00,$66,$C8,$80,$84,$06,$00     ;175
        DB $00,$00,$22,$60,$60,$21,$00,$07     ;176
        DB $00,$00,$44,$60,$60,$A4,$06,$0C     ;177
        DB $00,$00,$77,$00,$10,$21,$07,$00     ;178
        DB $00,$00,$EE,$C4,$80,$00,$0E,$00     ;179
        DB $00,$00,$00,$00,$55,$50,$50,$07     ;180
        DB $88,$80,$80,$08,$66,$51,$61,$04     ;181
        DB $11,$00,$00,$01,$55,$50,$50,$07     ;182
        DB $88,$40,$80,$0C,$66,$51,$61,$04     ;183
        DB $00,$00,$00,$00,$35,$70,$87,$F0     ;184
        DB $00,$00,$00,$00,$CE,$E6,$1E,$F0     ;185
        DB $11,$30,$10,$01,$10,$10,$34,$78     ;186
        DB $88,$C4,$80,$08,$80,$80,$E2,$F1     ;187
        DB $22,$75,$70,$34,$12,$01,$00,$00     ;188
        DB $22,$75,$F8,$E1,$C2,$84,$08,$00     ;189
        DB $33,$74,$CA,$CB,$34,$20,$14,$03     ;190
        DB $CC,$E2,$94,$96,$F0,$A0,$40,$0C     ;191
        DB $11,$10,$10,$10,$76,$70,$10,$01     ;192
        DB $88,$88,$88,$88,$E6,$E0,$80,$08     ;193
        DB $11,$10,$10,$10,$33,$30,$10,$01     ;194
        DB $88,$88,$88,$88,$C4,$C0,$80,$08     ;195
        DB $11,$10,$10,$10,$11,$11,$10,$01     ;196
        DB $88,$88,$88,$88,$80,$88,$80,$08     ;197
        DB $33,$54,$CC,$8F,$DB,$C0,$E2,$B3     ;198
        DB $EE,$B9,$99,$FF,$DD,$33,$2E,$0C     ;199
   

;Define a 256 x 192 screen 
	
CRTCConfig:
	db $7F		;0 - Horizontal total
	db $40		;1 - Horizontal displayed characters
	db $5A		;2 - Horizontal sync position
	db $28		;3 - Horizontal sync width/Vertical sync time
	db $26			;4 - Vertical total
	db $00			;5 - Vertical total adjust
	db 24			;6 - Vertical displayed characters (25)
	db 31			;7 - Vertical sync position
	db $01			;8 - Interlace/Display delay/Cursor delay
	db $07			;9 - Scan lines per character
	db %00110000	;10 - Cursor start line and blink type
	db $0			;11 - Cursor end line
	db $0A		;12 - Screen start address H (Address /8)
	db $00		;13 - Screen start address L 

	
ULAConfig:	
Palette0:	;Colours
;		SC  SC		-	S=Screen C=Color
	db $07,$17	;0
	db $47,$57	;0
Palette1:
	db $22,$32		;1
	db $62,$72		;1
Palette2:
	db $81,$91			;2
	db $C1,$D1			;2
Palette3:
	db $A0,$B0				;3
	db $E0,$F0				;3
	
;EOR True   Color
;7  (0) 	black
;6  (1) 	red
;5  (2) 	green
;4  (3) 	yellow (green—red)
;3  (4) 	blue
;2  (5) 	magenta (red—blue)
;1  (6) 	cyan (green—blue)
;0  (7) 	white


BBCLastByte: db 0