
slowdown:	;this exists for systems that run too fast
	nop
	nop
	nop
	nop
	nop
	nop
	rts

		
newline:
	lda #0		;new line
	sta z_d

	inc z_e

	lda z_e
	cmp #16			;at bottom of screen
	bcs lbl52779		;no? return, else cls!
	rts
lbl52779

cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #26
		sta z_h

		lda #$28		;width,height
		sta z_b
		lda #17
		sta z_c

		jsr fillarea
	pla
	sta	z_c
	pla
	sta z_b
	
	pla
	sta	z_l
	pla
	sta z_h
	rts

	
printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0

printchar:			;print char a with sprite routine	
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	
	tax
	pha
	
	lda z_d
	pha
	lda z_e
	pha
	
	lda z_b
	pha
	lda z_c
	pha
	
	lda z_h
	pha
	lda z_l
	pha
		txa
		sec
		sbc #32					;no char below 32
		cmp #64
		bcc notlowercase
			sec
			sbc #32		;we don't define lowercase, convert to upper!
notlowercase:		
			asl			;*2
			sta z_l		
			lda #0
			sta z_h
			
			lda z_l
			asl			;*4
			rol z_h
			asl			;*8
			rol z_h
			asl			;*16
			rol z_h
			
			adc z_l		
			bcc PrintcharH
			inc z_h
			clc
PrintcharH
			adc #<Bitmapfont
			sta z_l
			
			lda z_h
			adc #>Bitmapfont
			sta z_h
				

		
		
		lda z_d	;Add Xpos
		sta z_c
		asl	
		clc
		adc z_c			;*3
		sta z_c
		
	
		lda #$C0		;ScreenBase=$C000
		sta z_b
		
		lda z_e
		beq PrintChary0
PrintCharyMult:
		lda #$E0		;Ypos*$1E0
		adc z_c
		sta z_c
		
		lda z_b
		adc #1
		sta z_b
		
		dec z_e
		bne PrintCharyMult
PrintChary0:

		ldx #6
PrintCharByteY:
		ldy #2
PrintCharByteX:			
		lda (z_hl),y
		sta (z_bc),y
		dey 
		bpl PrintCharByteX
		clc
		lda #$50		;Move Down 1 Line ($50 Bytes)
		adc z_c
		sta z_c
		lda #0
		adc z_b
		sta z_b
		
		lda #3
		adc z_l
		sta z_l
		lda z_h
		adc #0
		sta z_h
		
		dex 
		bne PrintCharByteY
	pla
	sta	z_l
	pla
	sta z_h
	pla
	sta	z_c
	pla
	sta z_b
	pla
	sta	z_e
	pla
	sta z_d
	;pullpairsafe z_bc
	pla
	inc z_d
	rts

	
ReadJoystick:
	lda #$FF
	sta z_h			;Player 1 
	;sta z_l			;Player 2 - Only one pad so disabled
	
	eor $FCB0		;JOYSTICK	Read Joystick and Switches	UDLR12IO
			;(I= Inside Fire, O=Outside Fire, 1=Option 1, 2=Option 2)
			
	;FCB1 = Pause button on bit 0
			
	jsr SwapNibbles	; swap UDLR12IO to 12IOUDLR	
	tay				;Back up for later

	ldx #4
JoystickNextBitsB:	;shift 12IOUDLR into ---RLDU
	ror
	rol z_h			;Flip the order of the bits
	dex
	bne JoystickNextBitsB
	
	tya				;Get back backup 12IOUDLR
	ora #%00001111	;Get Fires 12IO---
	and z_h			;Or in ---RLDU
	sta z_h
	rts

	
		
SwapNibbles:		;$AB -> $BA
		ASL 		;(shift left - bottom bit zero)
		ADC #$80 	;(pop top bit off - add carry)
		ROL 		;(shift carry in)
		;2 bits moved
		ASL 		;(shift left - bottom bit zero)
		ADC #$80 	;(pop top bit off - add carry)
		ROL 		;(shift carry in)
		;4 bits moved
		rts
		
	
Bitmapfont:		
	ds 18
	incbin "\ResAll\ChibiAdventure\Font6x6.raw"			
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
	
	org $fffe
	dw ProgramStart			;Reset Vector 
	