
slowdown:	;this exists for systems that run too fast
	nop
	nop
	nop
	nop
	nop
	nop
	rts

		
newline:
	lda #0		;new line
	sta z_d

	inc z_e

	lda z_e
	cmp #23			;at bottom of screen
	bcs lbl52779		;no? return, else cls!
	rts
lbl52779

cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #$20
		sta z_h

		lda #32		;width,height
		sta z_b
		lda #24
		sta z_c
		jsr NesDisableScreen
		jsr fillarea
		jsr NesEnableScreen
	pla
	sta	z_c
	pla
	sta z_b
	
	pla
	sta	z_l
	pla
	sta z_h
	rts

	
printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0

printchar:			;print char a with sprite routine	
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	;tax
	pha
	;pushpair z_bc
	;lda z_d
	;pha
	;lda z_e
	;pha
	
	;lda z_h
	;pha
	;lda z_l
	;pha
		;txa
		sec
		sbc #32					;no char below 32
		cmp #64
		bcc notlowercase
		sec
		sbc #32		;we don't define lowercase, convert to upper!
notlowercase:
		pha
	
	
		;Address= $2000 + (Ypos*32) + Xpos
		lda z_e
		asl				;%00000111
		asl
		asl
		asl
		asl				;%11100000
		ora z_d
		tay				;L Byte
		
		lda z_e
		lsr				;%11111000
		lsr
		lsr				;%00011111
		clc
		adc #$20		;Tilemap Base (Nametable) = $2000
		tax				;Hbyte
			
		jsr waitframe	;Can only Write to VRAM in Vblank
		
		stx $2006		;PPUADDR High byte
		sty $2006		;PPUADDR Low byte
		
	
		pla
		sta $2007		;PPUDATA
		
	
		;Need to reset scroll each write	
		lda #0			;Scroll X
		sta $2005		;PPUSCROLL
		lda #0-8		;Scroll y
		sta $2005		;PPUSCROLL
			
	;pla
	;sta	z_l
	;pla
	;sta z_h
	;pla
	;sta	z_e
	;pla
	;sta z_d
	;pullpairsafe z_bc
	pla
	inc z_d
	rts


NesDisableScreen:			;Turn OFF the screen
;(Sprite enable/back enable/Sprite leftstrip / backleftstrip)
	lda #%00000000	
	sta $2001				;PPUMASK
	;lda #$00				;NMI disable (Vblank)
	sta $2000				;PPUCTRL - VPHB SINN
	sta ScreenOn
	rts	
	
		
NesEnableScreen:			;Turn ON the screenY
;(Sprite enable/back enable/Sprite leftstrip / backleftstrip)
	lda #%00011110 	
	sta $2001				;PPUMASK
	lda #$88				;NMI enable (Vblank) + Sprite patterns at $1000
	sta $2000				;PPUCTRL - VPHB SINN
	sta ScreenOn
	rts
	

readjoystick:
	;Strobe joysticks to reset them
	ldx #$01				;Send a 1 to joysticks (strobe reset)
	stx $4016				;JOYPAD1 port
	
	dex 					;Send a 0 to joysticks (read data)
	stx $4016				;JOYPAD1 port

	ldx #8					;Read in 8 bits from each joystick
Player_ReadControlsDualloop:
	lda $4016				;JOYPAD1
	lsr 	   				; bit0 -> Carry
	ror z_h  				;Add carry to Joy1 data
  
	lda $4017				;JOYPAD2
	lsr 	   				; bit0 -> Carry
	ror z_l  				;Add carry to Joy2 data
  
	dex 
	bne Player_ReadControlsDualloop
  
	lda z_h
	eor #255				;Flip bits so unpressed=1
	;jmp SwapNibbles
	

SwapNibbles:		;$AB -> $BA
		ASL 		;(shift left - bottom bit zero)
		ADC #$80 	;(pop top bit off - add carry)
		ROL 		;(shift carry in)
		;2 bits moved
		ASL 		;(shift left - bottom bit zero)
		ADC #$80 	;(pop top bit off - add carry)
		ROL 		;(shift carry in)
		;4 bits moved
		rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
Font_DoBitplane:
	ldx #8			;8 bytes per tile bitplane
FontFillAgain_Plane1:	
	lda (z_HL),y
	sta $2007		;Write data to data-port 
	iny
	dex 
	bne FontFillAgain_Plane1
	rts

Palette:  
; 	Color   3   2   1  0
		db $38,$21,$15,$02
	
Bitmapfont:					;Chibiakumas bitmap font
	incbin "\ResALL\Font96.FNT"
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
waitframe:
	pha
		lda ScreenOn
		beq waitframeScreenOff
		lda #$00
		sta vblanked		;Zero Vblanked
waitloop:
		lda vblanked		;Wait for the interrupt to change it
		beq waitloop
waitframeScreenOff:
	pla
	rts
	
	ifndef nmihandler
nmihandler:		;This procuedure runs after each frame (See footer.asm)
		php
		inc vblanked		;Alter Vblank Zero page entry
		plp
irqhandler:	;Do nothing
	endif
	rti
	
;Cartridge Footer	
	org $FFFA
	dw nmihandler			;FFFA - Interrupt handler
	dw ProgramStart			;FFFC - Entry point
	dw irqhandler			;FFFE - IRQ Handler
	
	
	
	