
z_Regs equ $20
ramarea equ $200


	org $BFF0

	db "NES",$1a		;ID
	db $01				;Rom pages (16k each)
	db $0				;CHR-ROM pages
	db %01000010		;mmmmFTBM		mmmm = mapper no bottom 4 bits , Four screen vram layout, Trainer at &7000, Battery ram at &6000, Mirror (0=horiz, 1=vert)
	db %00000000		;mmmm--PV 		mapper (top 4 bits...  Pc10 arcade, Vs unisystem )
	db 0				;Ram pages
	db 0,0,0,0,0,0,0
						;We selected Mapper 4 - it has 8k VRAM , 8K Sram and 128k rom
	

vblanked 	equ $7F		;Zero page address of Vblank count
ScreenOn	equ $80



	

ProgramStart:
	sei					;Interrupts off
	cld					;Clear Decimal flag
	
	ldx #$ff			;Set up stack
	txs
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;ScreenInit

	ldy #0
	;Pattern table &0000
	sty $2006		;PPUADDR H
	sty $2006		;PPUADDR L
	
	lda #BitmapFont&255	;Address of font
	sta z_L
	lda #BitmapFont/256
	sta z_H
	
	
	ldx #3	;Y=0 (768 lines total)
fontchar_loop:
	txa
	pha	
fontchar_loop2:
		tya
		pha
			jsr Font_DoBitplane	;Bitplane 0
		pla
		tay
		jsr Font_DoBitplane		;Bitplane 1
		
		tya
		bne fontchar_loop2		;Repeat until Y=0
	inc z_H
	pla
	tax
	dex
	bne fontchar_loop
	
	
;Palette
	lda #$3F		;Select Palette ram &3F00
	sta $2006		;PPUADDR H
	txa ;X=0
	sta $2006		;PPUADDR L
	
	ldx #4
PaletteAgain
	lda Palette-1,x 
	sta $2007		;PPUDATA
	dex 
	bne PaletteAgain

;Turn ON the screen
	jsr NesEnableScreen


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	jsr ClearRam
	