
slowdown:	;this exists for systems that run too fast
	nop
	nop
	nop
	nop
	nop
	nop
	rts

newline:
	stz z_d	;new line

	inc z_e

	lda z_e
	cmp #23			;at bottom of screen
	bcs cls		;no? return, else cls!
	rts
cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #$20
		sta z_h

		lda #$28		;width,height
		sta z_b
		lda #$19
		sta z_c

		jsr fillarea
	pla
	sta	z_c
	pla
	sta z_b
	pla
	sta	z_l
	pla
	sta z_h
	rts

	
printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0
	
printchar:			;print char a with sprite routine	
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	tax
	;pha
	;pushpair z_bc
	lda z_d
	pha
	lda z_e
	pha
		txa
		sec
		sbc #32					;no char below 32
		cmp #64
		bcc notlowercase
		sec
		sbc #32		;we don't define lowercase, convert to upper!
notlowercase:
		pha
			st0 #0			;Reg0=Select Addr
;Address=(Ypos *32) + X
			lda z_e
			asl				;%00000111
			asl
			asl
			asl
			asl				;%11100000
			ora z_d
			sta $0102		;Address L
			
			lda z_e
			lsr				;%11111000
			lsr
			lsr				;%00011111
			sta $0103		;Address H
	
			st0 #2			;Reg2=Write Byte Data
		pla
		sta $0102		;Store Char 
		st2 #%00000001	;Font Tile are 256+	
	pla
	sta	z_e
	pla
	sta z_d
	tax
	inc z_d
	rts

	
	
readjoystick:
Player_ReadControlsDual:
	;R:      3210
	;W:		   CS			C=Clear S=Select key/dir
	
	;Reset the Multitap... following reads will read in 
		;from joysticks 1-5
	ldx #%00000001			;Reset Multitap 1
	jsr JoypadSendCommand
	ldx #%00000011			;Reset Multitap 2
	jsr JoypadSendCommand

	;jsr Player_ReadControlsOne	;Read Pad 1
	;sta z_h
	;rts
	
								;Read Pad 2
Player_ReadControlsOne:	
	ldx #%00000001				
	jsr JoypadSendCommand	;----LDRU (Left/Down/Right/Up)
	jsr JoypadShiftFourBitsA
	dex
	jsr JoypadSendCommand	;---RSBA (Run/Start/B/A)
	jsr JoypadShiftFourBits
	lda z_as
	;sta z_l
	rts
	
JoypadShiftFourBitsA:		;Swap LDRU to RLDU
	ror						;Up
	ror z_as		
	ror						;Right (for later)
	ror z_l			
	ror						;Down
	ror z_as
	ror						;Left
	ror z_as
	rol z_l					;Right
	ror z_as
	rts	

JoypadShiftFourBits:		;Shift RSBA in to z_as
	ldx #4
JoypadShiftFourBitsB:
	ror
	ror z_as
	dex
	bne JoypadShiftFourBitsB
	rts
	
JoypadSendCommand:
	stx $1000			;Set option from X
	
	PHA 				;Delay
	PLA 
	NOP 
	NOP
	
	lda $1000			;Load result
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		

FontPart:
	ldx #8 
FontPartAgain:
	lda ($60),Y	
	sta $0102		
	sta $0103		
	iny
	dex
	BNE FontPartAgain		;Write the first 8 lines 
	rts
	
Bitmapfont:								
	incbin "\ResALL\Font96.FNT"			
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
	
	
	
	org $ffff
	db $0			;End of cartridge
	
	