
slowdown:	;this exists for systems that run too fast
	rts

		
newline:
	lda #0		;new line
	sta z_d

	inc z_e

	lda z_e
	cmp #23			;at bottom of screen
	bcs lbl52779		;no? return, else cls!
	rts
lbl52779

cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #$20
		sta z_h

		lda #40		;width,height
		sta z_b
		lda #$19
		sta z_c

		jsr fillarea
	pla
	sta	z_c
	pla
	sta z_b
	
	pla
	sta	z_l
	pla
	sta z_h
	rts


printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0

printchar:			;print char a with sprite routine
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	
	tax
	pha
	;pushpair z_bc
	lda z_d
	pha
	lda z_e
	pha
	
	lda z_h
	pha
	lda z_l
	pha
		lda #$80			;Screen base is $8000
		sta z_h		
		
		lda z_d				;Xpos
		ifdef ScreenWidth32
			clc
			adc #4
		endif
		sta z_l

		ldy z_e				;Ypos
		beq GetVDPScreenPos_YZero
		
		lda z_l
GetVDPScreenPos_Addagain:	;Repeatedly add screen width (22) Y times 
		clc
		adc #40			;40 bytes per line

		bcc GetVDPScreenPos_AddagainB
		inc z_h		;Add Carry
GetVDPScreenPos_AddagainB		
		dey
		bne GetVDPScreenPos_Addagain
		sta z_l
GetVDPScreenPos_YZero:	
		txa
		clc
		cmp #64	
		bcs PrintChar_Letters
;	sbc #32
		jmp PrintChar_Symbols
PrintChar_Letters:
		sbc #64;
		and #%00011111
PrintChar_Symbols:
		ldx #0
		sta (z_hl,x)
	pla
	sta	z_l
	pla
	sta z_h
	pla
	sta	z_e
	pla
	sta z_d
	;pullpairsafe z_bc
	pla
	inc z_d
	rts

	
	
			
;We Return ---FRLDU in z_h for Player 0, and z_L for Player 1

ReadJoystick:	;Returns %--21RLDU

	lda #6				;Line 6
	ldx #%00100000		;Fire 2 (Enter)
	jsr TestCursorBit
	
	lda #9				;Line 9
	ldx #%00000100		;Fire 1 (Space)
	jsr TestCursorBit
	
	lda #4				;Line 4
	ldx #%10000000		;Right (Numpad 6)
	jsr TestCursorBit
	
	;lda #4				;Line 4
	ldx #%01000000		;Left (Numpad 4)
	jsr TestCursorBit
	
	lda #7				;Line 7
	;ldx #%01000000		;Down (Numpad 2)
	jsr TestCursorBit
	
	lda #3				;Line 3
	;ldx #%01000000		;Up	(Numpad 8)
	jsr TestCursorBit
	lda z_As
	rts
	
TestCursorBit:				;A=Line X=Mask
	pha
		sta $E810			;Select line
		txa
		and $E812			;test key
		clc					;Clear carry (Pressed)
		beq TestCursorBitB		
		sec					;Set carry (not pressed)
TestCursorBitB:	
		rol z_As				;shift the key into the buildup
	pla
	rts
	