
slowdown:	;this exists for systems that run too fast
	nop
	nop
	nop
	nop
	nop
	nop
	rts

		
newline:
	lda #0		;new line
	sta z_d

	inc z_e

	lda z_e
	cmp #23			;at bottom of screen
	bcs lbl52779		;no? return, else cls!
	rts
lbl52779

cls:
	lda z_h
	pha
	lda z_l
	pha
	lda z_b
	pha
	lda z_c
	pha
		lda #0
		sta z_d			;x,y
		sta z_e
		sta z_l			;char,inc
		lda #$20
		sta z_h

		lda #$28		;width,height
		sta z_b
		lda #$19
		sta z_c

		jsr fillarea
	pla
	sta	z_c
	pla
	sta z_b
	
	pla
	sta	z_l
	pla
	sta z_h
	rts

	
printnumber:		;print char a at loc de
	clc
	adc #48			;ascii 0

printchar:			;print char a with sprite routine	
	cmp #0
	bne Notprintchar0
;printchar0:
	inc z_d
	rts
Notprintchar0:	
	pha
		sec
		sbc #32					;no char below 32
		cmp #64
		bcc notlowercase
		sec
		sbc #32		;we don't define lowercase, convert to upper!
notlowercase:
		tax
		
			lda z_e 	
			sta z_as			;%YYYYYYYY 00000000
			lda #0
			lsr z_as			;%0YYYYYYY Y00000000
			ror 
			lsr z_as		;%00YYYYYY YY00000000
			ror 
			lsr z_as		;%000YYYYY YYY0000000
			ror 
			adc z_d
			tay
			
WaitVblank:
			lda $4212 			;HVBJOY - Status 	
				; xy00000a		- x=vblank state y=hblank state a=joypad ready
			and #%10000000
			beq WaitVblank	;Wait until we get nonzero - this means we're in VBLANK
		
			sty $2116		;MemL -Video port address [VMADDL/VMADDH]
			lda z_as
			sta $2117		;MemH
		
		stz $2119		;Top Tile Byte (0)
		stx $2118		;Bottom Tile Byte (TileNum)
		
		lda $4212 			;HVBJOY - Status 	
			; xy00000a		- x=vblank state y=hblank state a=joypad ready
		and #%10000000
		beq WaitVblank		;Did vblank end before we were done?
	
	;pullpairsafe z_bc
	pla
	inc z_d
	rts

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


readjoystick:
	;Strobe joysticks to reset them
	ldx #$01				;Send a 1 to joysticks (strobe reset)
	stx $4016				;JOYPAD1 port
	
	dex 					;Send a 0 to joysticks (read data)
	stx $4016				;JOYPAD1 port

	ldx #8					;Read in 8 bits from each joystick
Player_ReadControlsDualloop:
	lda $4016				;JOYPAD1
	lsr 	   				; bit0 -> Carry
	ror z_h  				;Add carry to Joy1 data
  
	lda $4017				;JOYPAD2
	lsr 	   				; bit0 -> Carry
	ror z_l  				;Add carry to Joy2 data
  
	dex 
	bne Player_ReadControlsDualloop
	
	lda z_h
	;jsr Player_ReadControlsCorrectOrder
	
	;Convert: Right Left Down Up Start Select B A
	;To:	  Start Select B A Right Left Down Up 
;Player_ReadControlsCorrectOrder:
	eor #255				;Flip bits so unpressed=1
	;jmp SwapNibbles
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SwapNibbles:		;$AB -> $BA
		ASL 		;(shift left - bottom bit zero)
		ADC #$80 	;(pop top bit off - add carry)
		ROL 		;(shift carry in)
		;2 bits moved
		ASL 		;(shift left - bottom bit zero)
		ADC #$80 	;(pop top bit off - add carry)
		ROL 		;(shift carry in)
		;4 bits moved
		rts
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
	
	
Font_DoBitplane:
		ldx #8				;8 Lines 
fontchar_loopL:
		lda ($20),y
		sta $2119			;Write Word data to data-port
		sta $2118			
		iny
		dex 
		bne fontchar_loopL
		rts
	
Bitmapfont:					;Chibiakumas bitmap font
	incbin "\ResALL\Font96.FNT"
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;	Footer
	
	org $FFC0
     ; "123456789012345678901"
	db "www.ChibiAkumas.com  "	; Program title (21 byte Ascii string)

	db $20		;Rom mode/speed (bits 7-4 = speed, bits 3-0 = map mode)
	db $00		;Rom type (bits 7-4 = co-processor, bits 3-0 = type)
	db $01 		;Rom size in banks (1bank=32k)
	db $00 		;Ram size (0=none)
	db $00		;Country/video refresh (ntsc 60hz, pal 50hz) (0=j 1=us/eu)
	db $00		;Developer id code
	db $00		;Rom version number
	db "cc"		;Complement check
	db "cs" 	;Checksum

;65816 mode vectors
	dw $0000 	;Reserved
	dw $0000 	;Reserved
	dw $0000 	;Cop vector   (cop opcode)
	dw $0000 	;Brk vector   (brk opcode)
	dw $0000 	;Abort vector (unused)
	ifdef CustomNmihandler
		dw CustomNmihandler	;Vblank interrupt handler
	else
		dw $0000	;Vblank interrupt handler
	endif
	dw $0000 	;Reset vector (unused)
	dw $0000 	;Irq vector   (h/v-timer/external interrupt)

;6502 mode vectors
	dw $0000 	;Reserved
	dw $0000	;Reserved
	dw $0000 	;Cop vector   (cop opcode)
	dw $0000 	;Brk vector   (unused)
	dw $0000 	;Abort vector (unused)
	ifdef CustomNmihandler
		dw CustomNmihandler	;Vblank interrupt handler		
	else
		dw $0000	;Vblank interrupt handler
	endif
	dw $8000 	;Reset vector (cpu is always in 6502 mode on reset)
	dw $0000 	;Irq/brk vector
	
	
	