	ifndef z_HL


z_BC equ z_Regs+0
z_C  equ z_Regs+0
z_B  equ z_Regs+1

z_DE equ z_Regs+2
z_E  equ z_Regs+2
z_D  equ z_Regs+3

z_HL equ z_Regs+4
z_L  equ z_Regs+4
z_H  equ z_Regs+5

z_As equ z_Regs+6
	endif


screenwidth equ ramarea+2



ClearRam:	
	lda #0
	tax
ClearRamAgain:
	sta ramarea,x
	inx
	bne ClearRamAgain

	ldx #16
ClearZpAgain:
	sta z_Regs,x
	dex
	bpl ClearZpAgain
	jmp cls


doldir:
		ldx #0
        lda (z_HL,x)
        sta (z_DE,x)
		jsr IncHL
		jsr IncDE
		jsr DecBC
		lda z_B
		ora z_C
		bne doldir
		rts
		
		

dolddr:
		ldx #0
        lda (z_HL,x)
        sta (z_DE,x)
		jsr DecHL
		jsr DecDE
		jsr DecBC
		lda z_B
		ora z_C
		bne dolddr
		rts
		
printseqfill:
	lda z_b
	pha
	lda z_c
	pha
;                                      	ld b,(hl)	
	ldx #0
	
	lda (z_hl,x)	;w
	sta z_b
	
	jsr inchl
	lda (z_hl,x)	;h
	sta z_c

	jsr inchl

	ldx #0
	lda (z_hl,x)	;char
;                                      	inc hl
	jsr inchl
	tay
	lda z_h
	pla
	lda z_l
	pha
		lda (z_hl,x)
		sta z_l
	
		tya
		sta z_h

		jsr fillarea
	pla
	sta z_l
	pla
	sta z_h
	jsr inchl
	jmp printseq_poprep

	
printseqcrnl:
	jsr newline		;zero x, move down a line
	jmp printseq


yposchange:
	cmp #251
	beq printseqfill		;&fb	 = fill area (w,h,char,inc)
	cmp #252
	beq printseqnc			;&fc 	 = new column (vertical)
	cmp #253
	beq printseqcrnl		;&fd     = new line (true)
	cmp #254
	beq printseqnl			;&fe     = new line (horizontal)
	cmp #255				;&ff     = end of list

	bne lbl38138		;yes? then return
	rts
lbl38138
	and #$1f
	sta z_e	;new ypos
	
	lda z_b
	sta z_d
	jmp printseqb
	
printseqnc:
	lda z_c								;restore ypos
	sta z_e

	inc z_d								;inc xpos
	jmp printseq
	
printseqnl:
	lda z_b								;restore xpos
	sta z_d
	
	inc z_e								;inc ypos
	
printseq:	;print seq hl at location de
	lda z_d
	sta z_b

	lda z_e
	sta z_c
	
;&00     = empty (nothing drawn)

printseqb:
	ldx #0
	lda (z_hl,x)						;get a char
	php
		jsr inchl			;move to next char
	plp
	beq doprintchar					;0=empty char
	cmp #32
	bcc xposchange			;&01-&1f = new absolute xpos (use nl for xpos=0)
	cmp #$e0
	bcs yposchange			;&e0-&f8 = new absolute ypos
	cmp #$a0
	bcs sequenceh			;&a0-&bf = horizontal sequence of one char
doprintchar:
	jsr printchar			;&20-&9f = character
	jmp printseqb
	
xposchange:
	sta z_d
	jmp printseq
	
sequenceh:
	tay
	lda z_b
	pha
	lda z_c
	pha
		tya
		cmp #$c0
	
		bcs sequencev			;&c0-&df = vertical sequence of one char
		and #$1f

		clc
		adc #1
		sta z_b

		ldx #0
		lda (z_hl,x)	;get a char
		jsr inchl		;move to next char

sequenceh2:
		jsr printchar
		dec z_b
		bne sequenceh2
printseq_poprep:
	pla
	sta z_c
	pla
	sta z_b
	jmp printseqb

sequencev:
	and #$1f
	clc
	adc #1
	sta z_b

	ldx #0
	lda (z_hl,x)	;get a char
	jsr inchl		;move to next char

sequencev2:
	pha
		tay
		lda z_d
		pha
		lda z_e
		pha
			tya
			jsr printchar
		pla
		sta z_e
		pla
		sta z_d
	pla
	inc z_e		;move down
	dec z_b
	bne sequencev2
	jmp printseq_poprep


waitforfire:
	jsr waitforrelease
waitforfire2:
	jsr dorandom
	jsr readjoystick
	and #%00010000
	bne waitforfire2
	rts

waitforrelease:
	jsr readjoystick
	cmp #255
	bne waitforrelease
	rts

pause50:
	lda #50
pausea:
	tay
	
	ldx #0

pausebc2:
	jsr SlowDown
	dex 
	bne pausebc2
	dey 
	bne pausebc2
	rts

showdecimal:		;draw a 3 digit decimal number (non-bcd)
	pha
	tay
	
	;pushpair z_bc
	lda z_b
	pha
	lda z_c
	pha
	
	lda z_h
	pha
		lda #100	;h=100 / l=10
		sta z_h
		tya
		jsr divideabyh	;/100
		
		lda #10
		sta z_h
		
		lda z_b
		jsr divideabyh	;/10
		lda z_b
		jsr printnumber	;/1
	pla 
	sta z_h
	;pullpair z_bc
	pla
	sta z_c
	pla
	sta z_b
	pla
	rts

divideabyh:
	pha
		lda #0
		sta z_c
	pla
dividebbyhagain:
	cmp z_h
	bcc dividebbyh_lessthan	;still >h
	inc z_c		;yes! count+1
	sec
	sbc z_h		;-h
	jmp dividebbyhagain
dividebbyh_lessthan:
	sta z_b			;remainder
	lda z_c			;count
	jmp printnumber

joyaxis:		;a=val c=joypresses
	sta z_b
	tax
;                                      	bit 0,c		;up or left
	lda z_c
	and #%00000001
	bne notupleft
	dex
notupleft:
	lda z_c
	and #%00000010	;down or right
	bne notdownright
	inx
notdownright:
	lsr z_c
	lsr z_c
	txa
	rts

rangedrandom:	;return a value between d and e
	jsr dorandom
	jsr rangetest
	bcs rangedrandom	;C=Out of range
	rts

rangelimit:	;reset a=b if over range de
	jsr rangetest
	bcc lbl57581
	lda z_b
lbl57581
	rts

rangetest:		;ensure a is between d and e
	cmp z_e
	bcs setcarry	;higher or equal to e
	cmp z_d
	bcc setcarry	;c=lower than d
	clc
	rts

setcarry:
	sec
	rts

	

;fill from (x,y) pos de with wid/hei bc with char h inc by l
fillarea:
	lda z_d
	pha
	lda z_e
	pha
fillareay:
		lda z_d
		pha
		lda z_e
		pha
		
		lda z_b
		pha
		lda z_c
		pha
fillareax:
			lda z_h		;char to show
			jsr printchar
			clc
			adc z_l		;move l chars
			
			sta z_h		;char to show next time

			dec z_b
			bne fillareax
			pla
			sta	z_c
			pla
			sta z_b
			pla
			sta	z_e
			pla
			sta z_d
	
	inc z_e				;next line
	dec z_c
	bne fillareay		;repeat for next line
	pla
	sta	z_e
	pla
	sta z_d
	rts
	
	
randomseed equ ramarea	;2 bytes

dorandom:
	lda z_b
	pha
	lda z_c
	pha
		lda randomseed
		sta z_c
		lda randomseed+1
		sta z_b
		jsr incbc
		lda z_c
		sta randomseed
		sta z_b
		sta randomseed+1
		lda z_b
		ora z_c
		ror
		eor z_h
		ror
		eor z_d
		eor z_c			
		ror
		eor z_l
		ror
		eor z_e
		eor z_b
		ror
		eor #%10011101
		eor z_c
		tax
	pla
	sta z_c
	pla 
	sta z_b
	txa
	rts


	

	ifndef IncBC	
IncBC:
		INC z_C
		BNE	IncBC_Done
		INC	z_B
IncBC_Done:
		rts
	endif
	
	ifndef IncHL		
IncDE:
		INC z_E
		BNE	IncDE_Done
		INC	z_D
IncDE_Done:
		rts
	endif
	
	ifndef IncHL	
IncHL:
		INC z_L
		BNE	IncHL_Done
		INC	z_H
IncHL_Done:
		rts
	endif
	
	ifndef DecBC
DecBC:	
		pha
			lda z_C
			bne DecBC_b
			DEC z_B
DecBC_b:	
			DEC z_C
		pla
		rts
	endif
	
	ifndef DecHL
DecHL:		
		pha
			lda z_L
			bne DecHL_h
			DEC z_H
DecHL_h:	
			DEC z_L
		pla
		rts
	endif
	
	ifndef DecDE
DecDE:		
		pha
			lda z_E
			bne DecDE_D
			DEC z_D
DecDE_D:	
			DEC z_E
		pla
		rts
	endif
	
