	include "\SrcAll\BasicMacros.asm"
; 10 SYS (4096)

SPpage equ $0100

*=$0801

        ;BYTE    $0E, $08, $0A, $00, $9E, $20, $28,  $34, $30, $39, $36, $29, $00, $00, $00 ;Start at $1000
;		BYTE    $0E, $08, $0A, $00, $9E, $20, $28,  $32, $33, $30, $34, $29, $00, $00, $00  ;Start at $0900
        BYTE    $0E, $08, $0A, $00, $9E, $20, $28,  $32, $30, $36, $34, $29, $00, $00, $00  ;Start at $0810

*=$0810

z_Regs equ $20
Cursor_X 	equ $40
Cursor_Y 	equ Cursor_X+1

;FourColor equ 1	

;PrintChar = $FFD2
	SEI			;Stop interrupts


		
		jsr ScreenInit
		jsr Cls
		
		lda #$00
		sta z_E
		sta z_L
		
		lda #$04
		sta z_D
		sta z_H
		
		jsr IncDE
		
		lda #$EF
		sta z_C
		
		lda #$03
		sta z_B
		
		lda #$76
		sta $0400
		
		jsr LDIR
		
	ifdef FourColor		
		lda #$00
		sta z_E
		sta z_L
		
		lda #$D8
		sta z_D
		sta z_H
		
		jsr IncDE
		
		lda #$EF
		sta z_C
		
		lda #$03
		sta z_B
		
		lda #$07
		sta $D800
		
		jsr LDIR
		
	endif
		ldx #0
		ldy #0
		jsr Locate
		
		jsr Monitor	
	
	lda #<MyText
	sta z_L
	lda #>MyText
	sta z_H
	jsr PrintString
	;jsr GraphicsTest

		
InfLoop:			
		jmp InfLoop
	
;        lda #>message
;        jsr printhex
;        jsr printhex
        jsr CLS
		jsr Monitor

        lda #$02
        sta z_B
        lda #$00
        sta z_C

		
		

 ;       jsr MemDump
 ;       word z_HL      ;Address
 ;       byte $1          ;Lines

        ;jsr IncBC
        ;bcc IncBCAgain

        jsr MemDump
        word $4000      ;Address
        byte $3          ;Lines

        lda #$40
        sta z_D
        lda #$00
        sta z_E

        lda #$00
        sta z_H
        lda #$00
        sta z_L

        lda #$00
        sta z_B
        lda #$05
        sta z_C
		
        
		lda #0
		tax
		jsr LDIR
TestDone:

        jsr MemDump
        word $4000      ;Address
        byte $3          ;Lines


        jsr MemDump
        word $0000      ;Address
        byte $3          ;Lines


        jsr MemDump
        word z_HL      ;Address
        byte $1          ;Lines

waitloop
        jmp waitloop

        sei
IncBC
        lda z_C
        bne IncBC_More
        lda z_B
        bne IncBC_NZ
        sec
        jmp IncBC_DONE
IncBC_NZ
        dec z_B
IncBC_More
        dec z_C
        clc
IncBC_DONE
        rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ScreenInit:
		lda $D011
        and #%10011111
        ora #%00100000
        sta $D011

        lda $D016              
        and #%11101111 
	ifdef FourColor
        ora #%00010000  ;1=Multicolor 4 color ;0=standard 2 color        
	endif
        sta $D016


        lda $D018
        and #%11110111
        ora #%00001000  ;1=Screen at %2000 (Other bits have no function in bitmap mode)
        sta $D018
	rts
PrintChar:

	clc
	sbc #31
	
	
	
	;lda #$8		;Char length
	sta z_C
	lda #$0
	sta z_B
	
	PushAll
	lda z_h
	pha
	lda z_l
	pha
	
	
	clc
	rol z_C
	rol z_B
	rol z_C
	rol z_B
	rol z_C
	rol z_B
	
	
	lda #<font
	sta z_L
	lda #>font
	sta z_H
	
	
	
	jsr addhl_bc;Select char
	
	
	
	
	

	
	lda #0
	sta z_d
	lda Cursor_X
	sta z_e
	clc
	rol z_e
	rol z_d
	rol z_e
	rol z_d
	rol z_e
	rol z_d
	ifdef FourColor
		rol z_e
		rol z_d
	endif
	
	lda #$01
	sta z_b
	lda #$40
	sta z_c
;	
	lda Cursor_Y;
	cmp #0
	beq PrintChar_NoY
	tay
PrintChar_Yagain;
	jsr AddDE_BC
	dey
	bne PrintChar_Yagain
PrintChar_NoY
	
	lda #$20	;Screen Offset
	sta z_b
	lda #$00
	sta z_c
	jsr AddDE_BC

	;ldx #0
	ldy #0
PrintChar_Loop
	ifdef FourColor
		lda #0
		sta z_as
	endif 
	lda (z_HL),y
	ifdef FourColor
		clc
		rol 
		rol z_as
		rol z_as
		rol 
		rol z_as
		rol z_as
		rol 
		rol z_as
		rol z_as
		rol 
		rol z_as
		;rol z_as
		
		lda z_as
		rol
		ora z_as
	endif 
    sta (z_DE),y
		
	;jsr IncHL
	;jsr IncDE
	iny
	;dey 
	tya
	cmp #8
	bne PrintChar_Loop
		
	ifdef FourColor
		lda #0
		sta z_b
		lda #8
		sta z_c
		jsr AddDE_BC
	
	
		;ldx #0
		ldy #0
PrintChar_Loop2:
		
		lda #0
		sta z_as
		lda (z_HL),Y

			clc
			ror 
			ror z_as
			ror z_as
			ror 
			ror z_as
			ror z_as
			ror 
			ror z_as
			ror z_as
			ror 
			ror z_as
			;rol z_as
			
			lda z_as
			ror
			ora z_as
		sta (z_DE),Y
			
		;jsr IncHL
		;jsr IncDE

		iny
		;dey 
		tya
		cmp #8
		bne PrintChar_Loop2
	endif
	
	inc Cursor_X
	lda Cursor_X
	ifdef FourColor
		cmp #20
	else
		cmp #40
	endif
	bne PrintChar_NotNextLine
	jsr NewLine
	
	;lda #0
	;sta Cursor_X
	;inc Cursor_Y
PrintChar_NotNextLine:
	
	
	pla
	sta z_l
	pla
	sta z_h	
	PullAll
	
	rts

Locate:
	stx Cursor_X 
	sty Cursor_Y
	rts
	
NewLine:
	lda #0
	sta Cursor_X	
	inc Cursor_Y
	rts
	;lda #13
	;jsr PrintChar
	;lda #10
	;jsr PrintChar
;	rts	
GraphicsTest:
        
		
		lda #<font
		sta z_L
		lda #>font
		sta z_H


        lda #$D8
        sta z_D
        lda #$00
        sta z_E

        ldy #0
		ldx #0
FillLoop
        lda (z_HL,x)		
        sta (z_DE,x)
		
		jsr IncHL
		jsr IncDE

        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop

        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop

	
        lda z_D
        cmp #$DC
        bne FillLoop


		rts
		
	include "\SrcAll\monitor.asm"
	include "\SrcAll\BasicFunctions.asm"
	include "WaitString.asm"

	
Cls
			
		ldx #0
		ldy #0
		jsr Locate
	ifdef FourColor
		lda #$02
	else
		lda #$04
	endif
		sta z_b
		lda #$00
		sta z_c
ClsAgain:		
		PushPair z_bc
			lda #' '
			jsr PrintChar
		PullPair z_bc
		jsr DecBC
		lda z_b
		ora z_c
		bne ClsAgain
		
				
		ldx #0
		ldy #0
		jsr Locate
        ;jsr $E518       ;Initialize VIC; restore default input/output to keyboard/screen; clear screen.
        ;jsr $E544       ;Clear screen.
        ;jsr $E566       ;Move cursor home, to upper left corner of screen.

        ;lda 23          ;21 for Graphics
        ;sta $D018      ;Set the charset
        rts

MyText
    db "Hello world!1234567890012356788",  255
	
font:
	incbin "Z:\ResALL\Font96.FNT"
	
	ALIGN 8

inputstring 
        db 255
